﻿'Description: Book record Navigation
'author: Joken Villanueva
'email address: joken000189561@gmail.com
'date created: Nov 28, 2013

Public Class Form1

    'cmd represent an SQL statement or stored procedure to execute against a data source
    Dim cmd As New OleDb.OleDbCommand
    'it represent data commands and database connection that are used to fill the dataset or datatable
    Dim da As New OleDb.OleDbDataAdapter
    'it represent an open connection to a data source and we equal this to our function name mycon()
    Dim con As OleDb.OleDbConnection = mycon()
    'we create data table as our imaginary table to our memory
    Dim maindt As New DataTable
    'this sql will hold later our SQL statements 
    Dim sql As String
    'our initial value for our minimun value to be used later for navigation
    Dim minval As Integer = 0
    'the integer thata will hold the maximum value
    Dim maxval As Integer

    Public Function mycon() As OleDb.OleDbConnection
        Return New OleDb.OleDbConnection("Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" & Application.StartupPath & "\lib.accdb")
    End Function

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Try
            'set the SQL Statements getting all the data of books
            sql = "Select * from tblbooks"
            'opens the connections
            con.Open()

            'gets the sql connection and storede procedure to execute the at the data source
            With cmd
                .CommandText = sql
                .Connection = con
            End With
            'get the stored procedure used to select records in the data source
            da.SelectCommand = cmd
            'refreshes the rows and fill the value to the Data table named maindt
            da.Fill(maindt)
            'Get the result number of result and assigne to maxval
            maxval = maindt.Rows.Count
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Information)
        End Try
        con.Close()

    End Sub

    Public Sub nav(ByVal a As Integer)
        Try
            'gets the value from the specific column in the data table 
            'and assign to a specific text box
            txtouttile.Text = maindt.Rows(a).Item(1)
            txtoutauthor.Text = maindt.Rows(a).Item(2)
            txtoutcategory.Text = maindt.Rows(a).Item(4)
            txtisbn.Text = maindt.Rows(a).Item(3)

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try

    End Sub


    Private Sub btnnext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnnext.Click
        'check if minval is not equal to maxval minus 1
        If minval <> maxval - 1 Then
            'minval is incremented by 1
            minval = minval + 1
            'throw the value of minval to nav procedure
            nav(minval)

        Else
            MsgBox("Last record!")
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'check if minval is still greater than zero
        If minval > 0 Then
            'minval will be decremented by one
            minval = minval - 1
            nav(minval)

        ElseIf minval = -1 Then
            MsgBox("No results found!")

        ElseIf minval = 0 Then
            MsgBox("First Record")
            nav(minval)
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If minval <> 0 Then
            minval = 0
            nav(minval)
        End If
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click

        If minval <> maxval Then
            minval = maxval - 1
            nav(minval)

        End If
    End Sub
End Class
